(* ------------------------------------------------------------------ *)
(* Prime Factors Kata                                                 *)
(* Version: 1.00                                                      *)
(* Author: Peter Kofler, www.code-cop.org                             *)
(* System: Turbo Pascal 6.01                                          *)
(* ------------------------------------------------------------------ *)
UNIT PrimeFac;

INTERFACE

USES Lists;

TYPE TPrimeFactors = OBJECT
        FUNCTION generate(i:Longint):ArrayListPtr;
     END;

{ simulate a static method with a global constant }
CONST PrimeFactors:TPrimeFactors = ();

IMPLEMENTATION

(*
FUNCTION TPrimeFactors.generate(i:Longint):ArrayListPtr;
VAR factors:ArrayListPtr;
    candidate:Longint;
BEGIN
   factors := new(ArrayListPtr, Init);

   FOR candidate := 2 TO i DO
   BEGIN
      WHILE i MOD candidate = 0 DO
      BEGIN
         factors^.Add(candidate);
         i := i DIV candidate;
      END;
   END;

   generate := factors;
END;
*)

FUNCTION TPrimeFactors.generate(i:Longint):ArrayListPtr;
VAR factors:ArrayListPtr;
    candidate:Longint;
BEGIN
   factors := new(ArrayListPtr, Init);

   FOR candidate := 2 TO Trunc(Sqrt(i)) DO 
   BEGIN
      WHILE i MOD candidate = 0 DO
      BEGIN
         factors^.Add(candidate);
         i := i DIV candidate;
      END;
   END;
   IF i <> 1 THEN factors^.Add(i);

   generate := factors;
END;

END.
